diff -U3 -r xv-3.10a/Makefile xv-3.10a.exif/Makefile
--- xv-3.10a/Makefile	2013-09-21 15:21:48.000000000 -0700
+++ xv-3.10a.exif/Makefile	2013-09-15 20:07:37.000000000 -0700
@@ -1,7 +1,7 @@
 # Makefile for xv
 
 # your C compiler (and options) of choice
-CC = cc
+CC = gcc
 #CC = gcc -ansi
 # note that -ansi kills __USE_MISC (gcc 2.95.3), which, at least on Linux,
 # determines whether stdlib.h includes prototypes for mktemp(), random(), etc.
@@ -18,11 +18,11 @@
 #       -Wuninitialized -Wparentheses
 
 
-CCOPTS = -O
+#CCOPTS = -O
 #
 # these are the usual optimization and warning options for gcc; all such
 # warnings but one (mktemp() use) have been eliminated (at least on Linux):
-#CCOPTS = -O3 -Wall
+CCOPTS = -O3 -Wall
 #
 # slightly more warnings... older code often made non-const pointers to
 # static strings (nothing should blow up unless something tries to write
@@ -125,7 +125,7 @@
 JPEGINC = -I$(JPEGDIR)/include
 #JPEGINC = -I$(JPEGDIR)
 ###
-JPEGLIB = -L$(JPEGDIR)/lib -ljpeg
+JPEGLIB = -L$(JPEGDIR)/lib -lturbojpeg -lexif
 #JPEGLIB = -L$(JPEGDIR) -ljpeg
 #JPEGLIB = $(JPEGDIR)/libjpeg.a
 ###
@@ -184,8 +184,8 @@
 #JP2KINC = -I$(JP2KDIR)
 JP2KINC = -I/usr/local/include
 ###
-#JP2KLIB = -L$(JP2KDIR) -ljasper
-JP2KLIB = $(JP2KDIR)/libjasper.a
+JP2KLIB = -L$(JP2KDIR) -ljasper
+#JP2KLIB = $(JP2KDIR)/libjasper.a
 
 
 ###
diff -U3 -r xv-3.10a/xvjpeg.c xv-3.10a.exif/xvjpeg.c
--- xv-3.10a/xvjpeg.c	2013-09-21 15:21:48.000000000 -0700
+++ xv-3.10a.exif/xvjpeg.c	2013-09-15 20:18:44.000000000 -0700
@@ -12,6 +12,9 @@
 
 #include <setjmp.h>
 
+#include <libexif/exif-loader.h>
+#include <libexif/exif-entry.h>
+
 #include "jpeglib.h"   /* currently defines JPEG_APP0 but not JPEG_APP1 */
 #include "jerror.h"
 
@@ -512,12 +515,15 @@
   byte                            *pic, *pic_end;
   long                             filesize;
   int                              i,w,h,bperpix,bperline,count;
+  ExifData *exif_data;
 
 
   fbasename = BaseName(fname);
   pic       = (byte *) NULL;
   comment   = (char *) NULL;
   exifInfo  = (byte *) NULL;
+  fp        = (FILE *) NULL;
+  exif_data = (ExifData *) NULL;
 
   pinfo->type  = PIC8;
 
@@ -536,7 +542,8 @@
 L1:
     /* if we're here, it blowed up... */
     jpeg_destroy_decompress(&cinfo);
-    fclose(fp);
+    if (exif_data) exif_data_free(exif_data);
+    if (fp)       fclose(fp);
     if (pic)      free(pic);
     if (comment)  free(comment);
     if (exifInfo) free(exifInfo);
@@ -562,15 +569,26 @@
   prog.progress_monitor = xv_prog_meter;
   cinfo.progress = &prog;
 
-  jpeg_stdio_src(&cinfo, fp);
+  int got_thumbnail = 0;
+  if (quick) {
+    ExifLoader *exif_loader = exif_loader_new();
+    if (exif_loader) {
+      exif_loader_write_file(exif_loader, fname);
+      exif_data = exif_loader_get_data(exif_loader);
+      exif_loader_unref(exif_loader);
+      if (exif_data->data && exif_data->size) {
+	jpeg_mem_src(&cinfo, exif_data->data, exif_data->size);
+	got_thumbnail = 1;
+      }
+    }
+  }
+  if (!got_thumbnail) {
+    jpeg_stdio_src(&cinfo, fp);
+  }
   (void) jpeg_read_header(&cinfo, TRUE);
 
-
-
   /* do various cleverness regarding decompression parameters & such... */
 
-
-
   jpeg_calc_output_dimensions(&cinfo);
   pinfo->normw = w = cinfo.output_width;
   pinfo->normh = h = cinfo.output_height;
@@ -764,7 +782,8 @@
 
   jpeg_finish_decompress(&cinfo);
   jpeg_destroy_decompress(&cinfo);
-  fclose(fp);
+  if (fp) fclose(fp);
+  if (exif_data) exif_data_free(exif_data);
 
   /* ownership transferred to pinfo */
   comment  = (char *) NULL;
